﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace FlyClass
{
    class Fly
    {
        private string _flyId;
        private double _xPosition;
        private double _yPosition;
        private double _xSpeed;
        private double _ySpeed;

        public Fly(string flyId)
        {
            _flyId = flyId;
            _xPosition = 0;
            _yPosition = 0;
            _xSpeed = 0;
            _ySpeed = 0;
        }

        public Fly(string flyId, double xPosition, double yPosition, double xSpeed, double ySpeed)
        {
            _flyId = flyId;
            _xPosition = xPosition;
            _yPosition = yPosition;
            _xSpeed = xSpeed;
            _ySpeed = ySpeed;
        }

        public string FlyId
        {
            get { return _flyId; }            
        }

        public double XPosition
        {
            get { return _xPosition; }
            set { _xPosition = value; }
        }

        public double YPosition
        {
            get { return _yPosition; }
            set { _yPosition = value; }
        }

        public double XSpeed
        {
            get { return _xSpeed; }
            set { _xSpeed = value; }
        }

        public double YSpeed
        {
            get { return _ySpeed; }
            set { _ySpeed = value; }
        }

        public void Move()
        {
            _xPosition += _xSpeed;
            _yPosition += _ySpeed;
        }

        public void Accelerate()
        {
            _xSpeed *= 1.1;
            _ySpeed *= 1.1;
        }

        public void Decelerate()
        {
            _xSpeed *= 0.9;
            _ySpeed *= 0.9;
        }

        public void Stop()
        {
            _xSpeed = 0;
            _ySpeed = 0;
        }

        public void Turn(double xSpeed, double ySpeed)
        {
            _xSpeed = xSpeed;
            _ySpeed = ySpeed;
        }

        public override string ToString()
        {
            return $"{nameof(_flyId)}: {_flyId}, {nameof(_xPosition)}: {_xPosition}, {nameof(_yPosition)}: {_yPosition}, {nameof(_xSpeed)}: {_xSpeed}, {nameof(_ySpeed)}: {_ySpeed}";
        }
    }
}
